#include "otabrowse5.h"
#pragma hdrstop

#include "module.h"
#include "moduleinfo.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TModuleForm *ModuleForm;
//---------------------------------------------------------------------------
__fastcall TModuleForm::TModuleForm(TComponent* Owner)
        : TForm(Owner), m(NULL), tlm(NULL), p(NULL), pg(NULL)
{
}

void __fastcall TModuleForm::FormShow(TObject *Sender)
{ tlm=NULL; p=NULL; pg=NULL;
  HRESULT tlmres=m->QueryInterface(__uuidof(IOTATypeLibModule),(void**)&tlm);
  HRESULT   pres=m->QueryInterface(__uuidof(IOTAProject),(void**)&p);
  HRESULT  pgres=m->QueryInterface(__uuidof(IOTAProjectGroup),(void**)&pg);
  PageControl->ActivePage=tsOperations;
  tsTypeLib->TabVisible=SUCCEEDED(tlmres);
  tsProject->TabVisible=SUCCEEDED(pres);
  tsProjectGroup->TabVisible=SUCCEEDED(pgres);
  //
  Caption=AnsiString("Module - ")+ExtractFileName(m->GetFileName());
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bCloseClick(TObject *Sender)
{ tClose->Caption=BoolToString(m->Close());
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bSaveClick(TObject *Sender)
{ tSave->Caption=BoolToString(m->Save(xSaveChangeName->Checked,xSaveForceSave->Checked));
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bCloseModuleClick(TObject *Sender)
{ tCloseModule->Caption=BoolToString(m->CloseModule(xCloseModuleForceClosed->Checked));
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bGetFileNameClick(TObject *Sender)
{ eFileName->Text=m->GetFileName();
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bSetFileNameClick(TObject *Sender)
{ m->SetFileName(eFileName->Text);
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bGetFileSystemClick(TObject *Sender)
{ eFileSystem->Text=m->GetFileSystem();
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bSetFileSystemClick(TObject *Sender)
{ m->SetFileSystem(eFileSystem->Text);
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bGetOwnerCountClick(TObject *Sender)
{ tGetOwnerCount->Caption=AnsiString(m->GetOwnerCount());
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bGetOwnerClick(TObject *Sender)
{ int i=eGetOwner->Text.ToInt();
  _di_IOTAProject tp=m->GetOwner(i);
  if (tp==NULL) Application->MessageBox("Owner not found","Get Owner",MB_OK);
  else
  { _di_IOTAModule tm=NULL;
    HRESULT res=tp->QueryInterface(__uuidof(IOTAModule),(void**)&tm);
    if (FAILED(res)) Application->MessageBox("Owner is not a module","Get Owner",MB_OK);
    else ShowModule(this,tm);
  }
}

//---------------------------------------------------------------------------
void __fastcall TModuleForm::bGetModuleFileCountClick(TObject *Sender)
{ tGetModuleFileCount->Caption=AnsiString(m->GetModuleFileCount());
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bGetModuleFileEditorClick(TObject *Sender)
{ int i=eGetModuleFileEditor->Text.ToInt();
  _di_IOTAEditor e = m->GetModuleFileEditor(i);
  if (e==NULL) Application->MessageBox("Editor not found","Get Module File Editor",MB_OK);
  else
  { ShowEditor(this,e);
  }
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bGetModuleCountClick(TObject *Sender)
{ tGetModuleCount->Caption=AnsiString(p->GetModuleCount());
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bGetModuleClick(TObject *Sender)
{ int i=eGetModule->Text.ToInt();
  _di_IOTAModuleInfo mi=p->GetModule(i);
  if (mi==NULL) Application->MessageBox("Module not found","Get Module",MB_OK);
  else ShowModuleInfo(this,mi);
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bAddFileClick(TObject *Sender)
{ p->AddFile(eAddRemoveFileName->Text,xIsUnitOrForm->Checked);
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bRemoveFileClick(TObject *Sender)
{ p->RemoveFile(eAddRemoveFileName->Text);
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bAddNewProjectClick(TObject *Sender)
{ pg->AddNewProject();
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bAddExistingProjectClick(TObject *Sender)
{ pg->AddExistingProject();
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bGetProjectCountClick(TObject *Sender)
{ tGetProjectCount->Caption=AnsiString(pg->GetProjectCount());
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bGetProjectClick(TObject *Sender)
{ int i=eGetProject->Text.ToInt();
  _di_IOTAProject tp=pg->GetProject(i);
  if (tp==NULL) Application->MessageBox("Project not found","Get Project",MB_OK);
  else
  { _di_IOTAModule tm=NULL;
    HRESULT res=tp->QueryInterface(__uuidof(IOTAModule),(void**)&tm);
    if (FAILED(res)) Application->MessageBox("Project is not a module","Get Project",MB_OK);
    else ShowModule(this,tm);
  }
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bGetActiveProjectClick(TObject *Sender)
{ _di_IOTAProject tp=pg->GetActiveProject();
  if (tp==NULL) Application->MessageBox("Project not found","Get Active Project",MB_OK);
  else
  { _di_IOTAModule tm=NULL;
    HRESULT res=tp->QueryInterface(__uuidof(IOTAModule),(void**)&tm);
    if (FAILED(res)) Application->MessageBox("Project is not a module","Get Active Project",MB_OK);
    else ShowModule(this,tm);
  }
}
//---------------------------------------------------------------------------
_di_IOTAProject __fastcall TModuleForm::NameToProject(AnsiString fn)
{ _di_IOTAModuleServices ms=NULL;
  HRESULT res=BorlandIDEServices->QueryInterface(__uuidof(IOTAModuleServices),(void**)&ms);
  if (FAILED(res)) return NULL;
  for (int i=0; i<ms->GetModuleCount(); i++)
  { _di_IOTAModule m=ms->Modules[i];
    AnsiString s=m->GetFileName();
    if (s==fn || ExtractFileName(s)==fn || ChangeFileExt(ExtractFileName(s),"")==fn)
    { _di_IOTAProject p=NULL;
      HRESULT res=m->QueryInterface(__uuidof(IOTAProject),(void**)&p);
      if (SUCCEEDED(res)) return p;
    }
  }
  return NULL;
}


void __fastcall TModuleForm::bRemoveProjectClick(TObject *Sender)
{ _di_IOTAProject tp= NameToProject(eRemoveSetProject->Text);
  if (tp==NULL) Application->MessageBox("Unrecognised project","Remove Project",MB_OK);
  else
  { pg->RemoveProject(tp);
  }
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bSetActiveProjectClick(TObject *Sender)
{ _di_IOTAProject tp= NameToProject(eRemoveSetProject->Text);
  if (tp==NULL) Application->MessageBox("Unrecognised project","Remove Project",MB_OK);
  else
  { pg->RemoveProject(tp);
  }
}
//---------------------------------------------------------------------------
void __fastcall TModuleForm::bAddNotifierClick(TObject *Sender)
{ ShowModuleNotifier(m);
}
//---------------------------------------------------------------------------

void __fastcall TModuleForm::bGetProjectOptionsClick(TObject *Sender)
{ _di_IOTAProjectOptions po=p->GetProjectOptions();
  if (po==NULL) Application->MessageBox("Couldn't find project options","Get Project options",MB_OK);
  else ShowProjectOptions(this,po);
}
//---------------------------------------------------------------------------

